DECLARE FUNCTION MikroTmr& (Flag%)

'-- mikrotmr.bas ----------------------------------------------- >>fst'01<< -
' - Demo, wie aus dem PIT 8253/8254 Zaehler 0 (2 Byte) und dem
'   Systemtimer (3 Byte) ein Timerwert gebildet wird.
' - Max. Messdauer knapp 30 Minuten,
'   danach Ueberlauf der Long-Integer Variablen.
' - Aufloesung des Zaehlers = 0.8380965 Mikrosekunden.
' - Es werden keine Manipulationen an den Timern vorgenommen.
' - Ungeeignet fuer kurze Delays, weil vor Messbeginn ein Zaehlersprung
'   des Systemtimers abgewartet werden muss.
' - PUBLIC DOMAIN
'-- V 20010916 ------------------------------ http://home.arcor.de/steini63 -

PRINT
PRINT " Mikrosekunden-Timer (Messdauer max. 30 Minuten)                    >>fst'01<<"

PRINT " SLEEP 1 dauert ... ";

dummy% = MikroTmr&(0)  'Uebergabe von 0 initialisiert den Timer
SLEEP 1                '1 Sekunde warten
micS& = MikroTmr&(1)   'Uebergabe eines Wertes <> 0 liefert die abgelaufene
                       ' Zeit in PIT-Ticks seit der Initialisierung

PRINT USING "  ########### Mikrosekunden"; micS&;
PRINT USING " =####.###### Sekunden"; micS& / 1000000

END

FUNCTION MikroTmr& (Flag%)

STATIC PIT01%, PIT02%, Tim01%, Tim02%, Tim03%

DEF SEG = 0

IF Flag% = 0 THEN             'Flag% = 0; Zaehler initialisieren:

 Tim00% = PEEK(&H46C)         'niederwertigstes Systemtimer-Byte lesen
 DO: Tim01% = PEEK(&H46C)     'Zaehlersprung abwarten
 LOOP WHILE Tim00% = Tim01%   ' --> WICHTIG, sonst Messfehler

 Tim02% = PEEK(&H46D)         'hoeherwertiges Systemtimer-Byte lesen
 Tim03% = PEEK(&H46E)         'hoechstwertiges Systemtimer-Byte lesen
 OUT &H43, 0                  'PIT Zaehlerstand intern speichern
 PIT01% = INP(&H40)           'niederwertiges PIT-Byte lesen
 PIT02% = INP(&H40)           'hoeherwertiges PIT-Byte lesen

ELSE                          'Flag% <> 0; Zeit seit Initialisierung messen:

 OUT &H43, 0                  'PIT Zaehlerstand intern speichern
 PIT11% = INP(&H40)           'niederwertiges PIT-Byte lesen
 PIT12% = INP(&H40)           'hoeherwertiges PIT-Byte lesen
 Tim11% = PEEK(&H46C)         'niederwertiges Systemtimer-Byte lesen
 Tim12% = PEEK(&H46D)         'hoeherwertiges Systemtimer-Byte lesen
 Tim13% = PEEK(&H46E)         'hoechstwertiges Systemtimer-Byte lesen

 PIT0& = 65535 - (PIT02% * 256& + PIT01%)         'PIT Startwert
 PIT1& = 65535 - (PIT12% * 256& + PIT11%)         'PIT Zielwert
 Tim0& = Tim03% * 65536 + Tim02% * 256& + Tim01%  'Systemtimer Startwert
 Tim1& = Tim13% * 65536 + Tim12% * 256& + Tim11%  'Systemtimer Zielwert

 'Zaehlersprung um Mitternacht ausgleichen:
 IF Tim0& > Tim1& THEN
   Tim0& = Tim0& - 1573040     'Zaehlermaximum ist 1.573.039
 END IF

 'Zeitdauer in Systemtimer-Ticks berechnen:
 Tim& = Tim1& - Tim0&

 'Gesamtzaehlerstand bestimmen,
 'der PIT-Startwert wird abgezogen, der PIT-Zielwert addiert:
 Tim& = Tim& * 65536 - PIT0& + PIT1&

 'In Mikrosekunden umrechnen:
 MikroTmr& = Tim& * .8380965

END IF
DEF SEG

END FUNCTION

